import type { BaseContract, BigNumberish, BytesLike, FunctionFragment, Result, Interface, AddressLike, ContractRunner, ContractMethod, Listener } from "ethers";
import type { TypedContractEvent, TypedDeferredTopicFilter, TypedEventLog, TypedListener, TypedContractMethod } from "../../common";
export interface ComptrollerStorageInterface extends Interface {
    getFunction(nameOrSignature: "PAUSER_ROLE" | "accountAssets" | "allMarkets" | "assetGroup" | "compLogic" | "globalConfig" | "governanceToken" | "interMintAllowed" | "isComptroller" | "lastBorrowedAt" | "liquidationIncentive" | "marketConfig" | "markets" | "oracle" | "pauseGuardian" | "redemptionManager" | "timelock"): FunctionFragment;
    encodeFunctionData(functionFragment: "PAUSER_ROLE", values?: undefined): string;
    encodeFunctionData(functionFragment: "accountAssets", values: [AddressLike, BigNumberish]): string;
    encodeFunctionData(functionFragment: "allMarkets", values: [BigNumberish]): string;
    encodeFunctionData(functionFragment: "assetGroup", values: [BigNumberish]): string;
    encodeFunctionData(functionFragment: "compLogic", values?: undefined): string;
    encodeFunctionData(functionFragment: "globalConfig", values?: undefined): string;
    encodeFunctionData(functionFragment: "governanceToken", values?: undefined): string;
    encodeFunctionData(functionFragment: "interMintAllowed", values?: undefined): string;
    encodeFunctionData(functionFragment: "isComptroller", values?: undefined): string;
    encodeFunctionData(functionFragment: "lastBorrowedAt", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "liquidationIncentive", values?: undefined): string;
    encodeFunctionData(functionFragment: "marketConfig", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "markets", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "oracle", values?: undefined): string;
    encodeFunctionData(functionFragment: "pauseGuardian", values?: undefined): string;
    encodeFunctionData(functionFragment: "redemptionManager", values?: undefined): string;
    encodeFunctionData(functionFragment: "timelock", values?: undefined): string;
    decodeFunctionResult(functionFragment: "PAUSER_ROLE", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "accountAssets", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "allMarkets", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "assetGroup", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "compLogic", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "globalConfig", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "governanceToken", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "interMintAllowed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isComptroller", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "lastBorrowedAt", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "liquidationIncentive", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "marketConfig", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "markets", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "oracle", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pauseGuardian", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "redemptionManager", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "timelock", data: BytesLike): Result;
}
export interface ComptrollerStorage extends BaseContract {
    connect(runner?: ContractRunner | null): ComptrollerStorage;
    waitForDeployment(): Promise<this>;
    interface: ComptrollerStorageInterface;
    queryFilter<TCEvent extends TypedContractEvent>(event: TCEvent, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TypedEventLog<TCEvent>>>;
    queryFilter<TCEvent extends TypedContractEvent>(filter: TypedDeferredTopicFilter<TCEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TypedEventLog<TCEvent>>>;
    on<TCEvent extends TypedContractEvent>(event: TCEvent, listener: TypedListener<TCEvent>): Promise<this>;
    on<TCEvent extends TypedContractEvent>(filter: TypedDeferredTopicFilter<TCEvent>, listener: TypedListener<TCEvent>): Promise<this>;
    once<TCEvent extends TypedContractEvent>(event: TCEvent, listener: TypedListener<TCEvent>): Promise<this>;
    once<TCEvent extends TypedContractEvent>(filter: TypedDeferredTopicFilter<TCEvent>, listener: TypedListener<TCEvent>): Promise<this>;
    listeners<TCEvent extends TypedContractEvent>(event: TCEvent): Promise<Array<TypedListener<TCEvent>>>;
    listeners(eventName?: string): Promise<Array<Listener>>;
    removeAllListeners<TCEvent extends TypedContractEvent>(event?: TCEvent): Promise<this>;
    PAUSER_ROLE: TypedContractMethod<[], [string], "view">;
    accountAssets: TypedContractMethod<[
        arg0: AddressLike,
        arg1: BigNumberish
    ], [
        string
    ], "view">;
    allMarkets: TypedContractMethod<[arg0: BigNumberish], [string], "view">;
    assetGroup: TypedContractMethod<[
        arg0: BigNumberish
    ], [
        [
            bigint,
            bigint,
            bigint,
            bigint,
            bigint,
            bigint
        ] & {
            groupId: bigint;
            intraCRatePercent: bigint;
            intraMintRatePercent: bigint;
            intraSuRatePercent: bigint;
            interCRatePercent: bigint;
            interSuRatePercent: bigint;
        }
    ], "view">;
    compLogic: TypedContractMethod<[], [string], "view">;
    globalConfig: TypedContractMethod<[
    ], [
        [
            bigint,
            bigint,
            bigint,
            bigint,
            bigint
        ] & {
            closeFactorPercent: bigint;
            minCloseValue: bigint;
            minSuBorrowValue: bigint;
            minWaitBeforeLiquidatable: bigint;
            largestGroupId: bigint;
        }
    ], "view">;
    governanceToken: TypedContractMethod<[], [string], "view">;
    interMintAllowed: TypedContractMethod<[], [boolean], "view">;
    isComptroller: TypedContractMethod<[], [boolean], "view">;
    lastBorrowedAt: TypedContractMethod<[arg0: AddressLike], [bigint], "view">;
    liquidationIncentive: TypedContractMethod<[
    ], [
        [
            bigint,
            bigint,
            bigint
        ] & {
            heteroPercent: bigint;
            homoPercent: bigint;
            sutokenPercent: bigint;
        }
    ], "view">;
    marketConfig: TypedContractMethod<[
        arg0: AddressLike
    ], [
        [
            boolean,
            boolean,
            boolean,
            boolean,
            bigint,
            bigint
        ] & {
            mintPaused: boolean;
            borrowPaused: boolean;
            transferPaused: boolean;
            seizePaused: boolean;
            borrowCap: bigint;
            supplyCap: bigint;
        }
    ], "view">;
    markets: TypedContractMethod<[
        arg0: AddressLike
    ], [
        [
            boolean,
            bigint,
            boolean
        ] & {
            isListed: boolean;
            assetGroupId: bigint;
            isComped: boolean;
        }
    ], "view">;
    oracle: TypedContractMethod<[], [string], "view">;
    pauseGuardian: TypedContractMethod<[], [string], "view">;
    redemptionManager: TypedContractMethod<[], [string], "view">;
    timelock: TypedContractMethod<[], [string], "view">;
    getFunction<T extends ContractMethod = ContractMethod>(key: string | FunctionFragment): T;
    getFunction(nameOrSignature: "PAUSER_ROLE"): TypedContractMethod<[], [string], "view">;
    getFunction(nameOrSignature: "accountAssets"): TypedContractMethod<[
        arg0: AddressLike,
        arg1: BigNumberish
    ], [
        string
    ], "view">;
    getFunction(nameOrSignature: "allMarkets"): TypedContractMethod<[arg0: BigNumberish], [string], "view">;
    getFunction(nameOrSignature: "assetGroup"): TypedContractMethod<[
        arg0: BigNumberish
    ], [
        [
            bigint,
            bigint,
            bigint,
            bigint,
            bigint,
            bigint
        ] & {
            groupId: bigint;
            intraCRatePercent: bigint;
            intraMintRatePercent: bigint;
            intraSuRatePercent: bigint;
            interCRatePercent: bigint;
            interSuRatePercent: bigint;
        }
    ], "view">;
    getFunction(nameOrSignature: "compLogic"): TypedContractMethod<[], [string], "view">;
    getFunction(nameOrSignature: "globalConfig"): TypedContractMethod<[
    ], [
        [
            bigint,
            bigint,
            bigint,
            bigint,
            bigint
        ] & {
            closeFactorPercent: bigint;
            minCloseValue: bigint;
            minSuBorrowValue: bigint;
            minWaitBeforeLiquidatable: bigint;
            largestGroupId: bigint;
        }
    ], "view">;
    getFunction(nameOrSignature: "governanceToken"): TypedContractMethod<[], [string], "view">;
    getFunction(nameOrSignature: "interMintAllowed"): TypedContractMethod<[], [boolean], "view">;
    getFunction(nameOrSignature: "isComptroller"): TypedContractMethod<[], [boolean], "view">;
    getFunction(nameOrSignature: "lastBorrowedAt"): TypedContractMethod<[arg0: AddressLike], [bigint], "view">;
    getFunction(nameOrSignature: "liquidationIncentive"): TypedContractMethod<[
    ], [
        [
            bigint,
            bigint,
            bigint
        ] & {
            heteroPercent: bigint;
            homoPercent: bigint;
            sutokenPercent: bigint;
        }
    ], "view">;
    getFunction(nameOrSignature: "marketConfig"): TypedContractMethod<[
        arg0: AddressLike
    ], [
        [
            boolean,
            boolean,
            boolean,
            boolean,
            bigint,
            bigint
        ] & {
            mintPaused: boolean;
            borrowPaused: boolean;
            transferPaused: boolean;
            seizePaused: boolean;
            borrowCap: bigint;
            supplyCap: bigint;
        }
    ], "view">;
    getFunction(nameOrSignature: "markets"): TypedContractMethod<[
        arg0: AddressLike
    ], [
        [
            boolean,
            bigint,
            boolean
        ] & {
            isListed: boolean;
            assetGroupId: bigint;
            isComped: boolean;
        }
    ], "view">;
    getFunction(nameOrSignature: "oracle"): TypedContractMethod<[], [string], "view">;
    getFunction(nameOrSignature: "pauseGuardian"): TypedContractMethod<[], [string], "view">;
    getFunction(nameOrSignature: "redemptionManager"): TypedContractMethod<[], [string], "view">;
    getFunction(nameOrSignature: "timelock"): TypedContractMethod<[], [string], "view">;
    filters: {};
}
